/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.extra;

import java.util.Map;
import rx.Observable;
import rx.Single;


@io.vertx.lang.rx.RxGen(io.vertx.codegen.extra.Generic.class)
public class Generic<T> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    Generic that = (Generic) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<Generic> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new Generic((io.vertx.codegen.extra.Generic) obj),
    Generic::getDelegate
  );

  private final io.vertx.codegen.extra.Generic<T> delegate;
  public final io.vertx.lang.rx.TypeArg<T> __typeArg_0;
  
  public Generic(io.vertx.codegen.extra.Generic delegate) {
    this.delegate = delegate;
    this.__typeArg_0 = io.vertx.lang.rx.TypeArg.unknown();  }

  public Generic(io.vertx.codegen.extra.Generic delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0) {
    this.delegate = delegate;
    this.__typeArg_0 = typeArg_0;
  }

  public io.vertx.codegen.extra.Generic getDelegate() {
    return delegate;
  }

  public T value() { 
    T ret = (T)__typeArg_0.wrap(delegate.value());
    return ret;
  }


  public static <T>Generic<T> newInstance(io.vertx.codegen.extra.Generic arg) {
    return arg != null ? new Generic<T>(arg) : null;
  }

  public static <T>Generic<T> newInstance(io.vertx.codegen.extra.Generic arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T) {
    return arg != null ? new Generic<T>(arg, __typeArg_T) : null;
  }
}
