/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.testmodel;

import java.util.Map;
import rx.Observable;
import rx.Single;
import java.util.Set;
import io.vertx.codegen.testmodel.TestDataObject;
import io.vertx.core.json.JsonArray;
import java.util.List;
import io.vertx.codegen.testmodel.TestEnum;
import java.util.Map;
import io.vertx.core.json.JsonObject;
import io.vertx.core.AsyncResult;
import io.vertx.core.Handler;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.CollectionTCK original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.codegen.testmodel.CollectionTCK.class)
public class CollectionTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    CollectionTCK that = (CollectionTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<CollectionTCK> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new CollectionTCK((io.vertx.codegen.testmodel.CollectionTCK) obj),
    CollectionTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.CollectionTCK delegate;
  
  public CollectionTCK(io.vertx.codegen.testmodel.CollectionTCK delegate) {
    this.delegate = delegate;
  }

  public io.vertx.codegen.testmodel.CollectionTCK getDelegate() {
    return delegate;
  }

  public void methodWithListParams(List<String> listString, List<Byte> listByte, List<Short> listShort, List<Integer> listInt, List<Long> listLong, List<JsonObject> listJsonObject, List<JsonArray> listJsonArray, List<io.vertx.rxjava.codegen.testmodel.RefedInterface1> listVertxGen, List<TestDataObject> listDataObject, List<TestEnum> listEnum, List<Object> listObject) { 
    delegate.methodWithListParams(listString, listByte, listShort, listInt, listLong, listJsonObject, listJsonArray, listVertxGen.stream().map(elt -> elt.getDelegate()).collect(java.util.stream.Collectors.toList()), listDataObject, listEnum, listObject);
  }

  public void methodWithSetParams(Set<String> setString, Set<Byte> setByte, Set<Short> setShort, Set<Integer> setInt, Set<Long> setLong, Set<JsonObject> setJsonObject, Set<JsonArray> setJsonArray, Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1> setVertxGen, Set<TestDataObject> setDataObject, Set<TestEnum> setEnum, Set<Object> setObject) { 
    delegate.methodWithSetParams(setString, setByte, setShort, setInt, setLong, setJsonObject, setJsonArray, setVertxGen.stream().map(elt -> elt.getDelegate()).collect(java.util.stream.Collectors.toSet()), setDataObject, setEnum, setObject);
  }

  public void methodWithMapParams(Map<String, String> mapString, Map<String, Byte> mapByte, Map<String, Short> mapShort, Map<String, Integer> mapInt, Map<String, Long> mapLong, Map<String, JsonObject> mapJsonObject, Map<String, JsonArray> mapJsonArray, Map<String, io.vertx.rxjava.codegen.testmodel.RefedInterface1> mapVertxGen, Map<String, Object> mapObject) { 
    delegate.methodWithMapParams(mapString, mapByte, mapShort, mapInt, mapLong, mapJsonObject, mapJsonArray, mapVertxGen.entrySet().stream().collect(java.util.stream.Collectors.toMap(e -> e.getKey(), e -> e.getValue().getDelegate())), mapObject);
  }

  public void methodWithHandlerListAndSet(Handler<List<String>> listStringHandler, Handler<List<Integer>> listIntHandler, Handler<Set<String>> setStringHandler, Handler<Set<Integer>> setIntHandler) { 
    delegate.methodWithHandlerListAndSet(listStringHandler, listIntHandler, setStringHandler, setIntHandler);
  }

  public void methodWithHandlerAsyncResultListString(Handler<AsyncResult<List<String>>> handler) { 
    delegate.methodWithHandlerAsyncResultListString(handler);
  }

    @Deprecated()
  public Observable<List<String>> methodWithHandlerAsyncResultListStringObservable() { 
    io.vertx.rx.java.ObservableFuture<List<String>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListString(handler.toHandler());
    return handler;
  }

  public Single<List<String>> rxMethodWithHandlerAsyncResultListString() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListString(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListInteger(Handler<AsyncResult<List<Integer>>> handler) { 
    delegate.methodWithHandlerAsyncResultListInteger(handler);
  }

    @Deprecated()
  public Observable<List<Integer>> methodWithHandlerAsyncResultListIntegerObservable() { 
    io.vertx.rx.java.ObservableFuture<List<Integer>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListInteger(handler.toHandler());
    return handler;
  }

  public Single<List<Integer>> rxMethodWithHandlerAsyncResultListInteger() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListInteger(fut);
    }));
  }

  public void methodWithHandlerListVertxGen(Handler<List<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> listHandler) { 
    delegate.methodWithHandlerListVertxGen(new Handler<java.util.List<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(java.util.List<io.vertx.codegen.testmodel.RefedInterface1> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toList()));
      }
    });
  }

  public void methodWithHandlerListAbstractVertxGen(Handler<List<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> listHandler) { 
    delegate.methodWithHandlerListAbstractVertxGen(new Handler<java.util.List<io.vertx.codegen.testmodel.RefedInterface2>>() {
      public void handle(java.util.List<io.vertx.codegen.testmodel.RefedInterface2> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface2.newInstance(elt)).collect(java.util.stream.Collectors.toList()));
      }
    });
  }

  public void methodWithHandlerListJsonObject(Handler<List<JsonObject>> listHandler) { 
    delegate.methodWithHandlerListJsonObject(listHandler);
  }

  public void methodWithHandlerListComplexJsonObject(Handler<List<JsonObject>> listHandler) { 
    delegate.methodWithHandlerListComplexJsonObject(listHandler);
  }

  public void methodWithHandlerListJsonArray(Handler<List<JsonArray>> listHandler) { 
    delegate.methodWithHandlerListJsonArray(listHandler);
  }

  public void methodWithHandlerListComplexJsonArray(Handler<List<JsonArray>> listHandler) { 
    delegate.methodWithHandlerListComplexJsonArray(listHandler);
  }

  public void methodWithHandlerListDataObject(Handler<List<TestDataObject>> listHandler) { 
    delegate.methodWithHandlerListDataObject(listHandler);
  }

  public void methodWithHandlerListEnum(Handler<List<TestEnum>> listHandler) { 
    delegate.methodWithHandlerListEnum(listHandler);
  }

  public void methodWithHandlerAsyncResultSetString(Handler<AsyncResult<Set<String>>> handler) { 
    delegate.methodWithHandlerAsyncResultSetString(handler);
  }

    @Deprecated()
  public Observable<Set<String>> methodWithHandlerAsyncResultSetStringObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<String>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetString(handler.toHandler());
    return handler;
  }

  public Single<Set<String>> rxMethodWithHandlerAsyncResultSetString() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetString(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetInteger(Handler<AsyncResult<Set<Integer>>> handler) { 
    delegate.methodWithHandlerAsyncResultSetInteger(handler);
  }

    @Deprecated()
  public Observable<Set<Integer>> methodWithHandlerAsyncResultSetIntegerObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<Integer>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetInteger(handler.toHandler());
    return handler;
  }

  public Single<Set<Integer>> rxMethodWithHandlerAsyncResultSetInteger() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetInteger(fut);
    }));
  }

  public void methodWithHandlerSetVertxGen(Handler<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> listHandler) { 
    delegate.methodWithHandlerSetVertxGen(new Handler<java.util.Set<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(java.util.Set<io.vertx.codegen.testmodel.RefedInterface1> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toSet()));
      }
    });
  }

  public void methodWithHandlerSetAbstractVertxGen(Handler<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> listHandler) { 
    delegate.methodWithHandlerSetAbstractVertxGen(new Handler<java.util.Set<io.vertx.codegen.testmodel.RefedInterface2>>() {
      public void handle(java.util.Set<io.vertx.codegen.testmodel.RefedInterface2> event) {
        listHandler.handle(event.stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface2.newInstance(elt)).collect(java.util.stream.Collectors.toSet()));
      }
    });
  }

  public void methodWithHandlerSetJsonObject(Handler<Set<JsonObject>> listHandler) { 
    delegate.methodWithHandlerSetJsonObject(listHandler);
  }

  public void methodWithHandlerSetComplexJsonObject(Handler<Set<JsonObject>> listHandler) { 
    delegate.methodWithHandlerSetComplexJsonObject(listHandler);
  }

  public void methodWithHandlerSetJsonArray(Handler<Set<JsonArray>> listHandler) { 
    delegate.methodWithHandlerSetJsonArray(listHandler);
  }

  public void methodWithHandlerSetComplexJsonArray(Handler<Set<JsonArray>> setHandler) { 
    delegate.methodWithHandlerSetComplexJsonArray(setHandler);
  }

  public void methodWithHandlerSetDataObject(Handler<Set<TestDataObject>> setHandler) { 
    delegate.methodWithHandlerSetDataObject(setHandler);
  }

  public void methodWithHandlerSetEnum(Handler<Set<TestEnum>> setHandler) { 
    delegate.methodWithHandlerSetEnum(setHandler);
  }

  public void methodWithHandlerAsyncResultListVertxGen(Handler<AsyncResult<List<io.vertx.rxjava.codegen.testmodel.RefedInterface1>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListVertxGen(new Handler<AsyncResult<java.util.List<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<java.util.List<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toList())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<List<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> methodWithHandlerAsyncResultListVertxGenObservable() { 
    io.vertx.rx.java.ObservableFuture<List<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListVertxGen(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultListVertxGen() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListVertxGen(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListAbstractVertxGen(Handler<AsyncResult<List<io.vertx.rxjava.codegen.testmodel.RefedInterface2>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListAbstractVertxGen(new Handler<AsyncResult<java.util.List<io.vertx.codegen.testmodel.RefedInterface2>>>() {
      public void handle(AsyncResult<java.util.List<io.vertx.codegen.testmodel.RefedInterface2>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface2.newInstance(elt)).collect(java.util.stream.Collectors.toList())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<List<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> methodWithHandlerAsyncResultListAbstractVertxGenObservable() { 
    io.vertx.rx.java.ObservableFuture<List<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListAbstractVertxGen(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> rxMethodWithHandlerAsyncResultListAbstractVertxGen() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListAbstractVertxGen(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListJsonObject(Handler<AsyncResult<List<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListJsonObject(listHandler);
  }

    @Deprecated()
  public Observable<List<JsonObject>> methodWithHandlerAsyncResultListJsonObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<List<JsonObject>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListJsonObject(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<JsonObject>> rxMethodWithHandlerAsyncResultListJsonObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListJsonObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListComplexJsonObject(Handler<AsyncResult<List<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListComplexJsonObject(listHandler);
  }

    @Deprecated()
  public Observable<List<JsonObject>> methodWithHandlerAsyncResultListComplexJsonObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<List<JsonObject>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListComplexJsonObject(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<JsonObject>> rxMethodWithHandlerAsyncResultListComplexJsonObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListComplexJsonObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListJsonArray(Handler<AsyncResult<List<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListJsonArray(listHandler);
  }

    @Deprecated()
  public Observable<List<JsonArray>> methodWithHandlerAsyncResultListJsonArrayObservable() { 
    io.vertx.rx.java.ObservableFuture<List<JsonArray>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListJsonArray(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<JsonArray>> rxMethodWithHandlerAsyncResultListJsonArray() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListJsonArray(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListComplexJsonArray(Handler<AsyncResult<List<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListComplexJsonArray(listHandler);
  }

    @Deprecated()
  public Observable<List<JsonArray>> methodWithHandlerAsyncResultListComplexJsonArrayObservable() { 
    io.vertx.rx.java.ObservableFuture<List<JsonArray>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListComplexJsonArray(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<JsonArray>> rxMethodWithHandlerAsyncResultListComplexJsonArray() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListComplexJsonArray(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListDataObject(Handler<AsyncResult<List<TestDataObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListDataObject(listHandler);
  }

    @Deprecated()
  public Observable<List<TestDataObject>> methodWithHandlerAsyncResultListDataObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<List<TestDataObject>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListDataObject(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<TestDataObject>> rxMethodWithHandlerAsyncResultListDataObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListDataObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultListEnum(Handler<AsyncResult<List<TestEnum>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultListEnum(listHandler);
  }

    @Deprecated()
  public Observable<List<TestEnum>> methodWithHandlerAsyncResultListEnumObservable() { 
    io.vertx.rx.java.ObservableFuture<List<TestEnum>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultListEnum(listHandler.toHandler());
    return listHandler;
  }

  public Single<List<TestEnum>> rxMethodWithHandlerAsyncResultListEnum() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultListEnum(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetVertxGen(Handler<AsyncResult<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetVertxGen(new Handler<AsyncResult<java.util.Set<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<java.util.Set<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toSet())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> methodWithHandlerAsyncResultSetVertxGenObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetVertxGen(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultSetVertxGen() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetVertxGen(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetAbstractVertxGen(Handler<AsyncResult<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface2>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetAbstractVertxGen(new Handler<AsyncResult<java.util.Set<io.vertx.codegen.testmodel.RefedInterface2>>>() {
      public void handle(AsyncResult<java.util.Set<io.vertx.codegen.testmodel.RefedInterface2>> ar) {
        if (ar.succeeded()) {
          listHandler.handle(io.vertx.core.Future.succeededFuture(ar.result().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface2.newInstance(elt)).collect(java.util.stream.Collectors.toSet())));
        } else {
          listHandler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> methodWithHandlerAsyncResultSetAbstractVertxGenObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetAbstractVertxGen(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<io.vertx.rxjava.codegen.testmodel.RefedInterface2>> rxMethodWithHandlerAsyncResultSetAbstractVertxGen() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetAbstractVertxGen(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetJsonObject(Handler<AsyncResult<Set<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetJsonObject(listHandler);
  }

    @Deprecated()
  public Observable<Set<JsonObject>> methodWithHandlerAsyncResultSetJsonObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<JsonObject>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetJsonObject(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<JsonObject>> rxMethodWithHandlerAsyncResultSetJsonObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetJsonObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetComplexJsonObject(Handler<AsyncResult<Set<JsonObject>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetComplexJsonObject(listHandler);
  }

    @Deprecated()
  public Observable<Set<JsonObject>> methodWithHandlerAsyncResultSetComplexJsonObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<JsonObject>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetComplexJsonObject(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<JsonObject>> rxMethodWithHandlerAsyncResultSetComplexJsonObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetComplexJsonObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetJsonArray(Handler<AsyncResult<Set<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetJsonArray(listHandler);
  }

    @Deprecated()
  public Observable<Set<JsonArray>> methodWithHandlerAsyncResultSetJsonArrayObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<JsonArray>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetJsonArray(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<JsonArray>> rxMethodWithHandlerAsyncResultSetJsonArray() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetJsonArray(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetComplexJsonArray(Handler<AsyncResult<Set<JsonArray>>> listHandler) { 
    delegate.methodWithHandlerAsyncResultSetComplexJsonArray(listHandler);
  }

    @Deprecated()
  public Observable<Set<JsonArray>> methodWithHandlerAsyncResultSetComplexJsonArrayObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<JsonArray>> listHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetComplexJsonArray(listHandler.toHandler());
    return listHandler;
  }

  public Single<Set<JsonArray>> rxMethodWithHandlerAsyncResultSetComplexJsonArray() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetComplexJsonArray(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetDataObject(Handler<AsyncResult<Set<TestDataObject>>> setHandler) { 
    delegate.methodWithHandlerAsyncResultSetDataObject(setHandler);
  }

    @Deprecated()
  public Observable<Set<TestDataObject>> methodWithHandlerAsyncResultSetDataObjectObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<TestDataObject>> setHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetDataObject(setHandler.toHandler());
    return setHandler;
  }

  public Single<Set<TestDataObject>> rxMethodWithHandlerAsyncResultSetDataObject() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetDataObject(fut);
    }));
  }

  public void methodWithHandlerAsyncResultSetEnum(Handler<AsyncResult<Set<TestEnum>>> setHandler) { 
    delegate.methodWithHandlerAsyncResultSetEnum(setHandler);
  }

    @Deprecated()
  public Observable<Set<TestEnum>> methodWithHandlerAsyncResultSetEnumObservable() { 
    io.vertx.rx.java.ObservableFuture<Set<TestEnum>> setHandler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultSetEnum(setHandler.toHandler());
    return setHandler;
  }

  public Single<Set<TestEnum>> rxMethodWithHandlerAsyncResultSetEnum() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultSetEnum(fut);
    }));
  }

  public Map<String, String> methodWithMapStringReturn(Handler<String> handler) { 
    Map<String, String> ret = delegate.methodWithMapStringReturn(handler);
    return ret;
  }

  public Map<String, Long> methodWithMapLongReturn(Handler<String> handler) { 
    Map<String, Long> ret = delegate.methodWithMapLongReturn(handler);
    return ret;
  }

  public Map<String, Integer> methodWithMapIntegerReturn(Handler<String> handler) { 
    Map<String, Integer> ret = delegate.methodWithMapIntegerReturn(handler);
    return ret;
  }

  public Map<String, Short> methodWithMapShortReturn(Handler<String> handler) { 
    Map<String, Short> ret = delegate.methodWithMapShortReturn(handler);
    return ret;
  }

  public Map<String, Byte> methodWithMapByteReturn(Handler<String> handler) { 
    Map<String, Byte> ret = delegate.methodWithMapByteReturn(handler);
    return ret;
  }

  public Map<String, Character> methodWithMapCharacterReturn(Handler<String> handler) { 
    Map<String, Character> ret = delegate.methodWithMapCharacterReturn(handler);
    return ret;
  }

  public Map<String, Boolean> methodWithMapBooleanReturn(Handler<String> handler) { 
    Map<String, Boolean> ret = delegate.methodWithMapBooleanReturn(handler);
    return ret;
  }

  public Map<String, Float> methodWithMapFloatReturn(Handler<String> handler) { 
    Map<String, Float> ret = delegate.methodWithMapFloatReturn(handler);
    return ret;
  }

  public Map<String, Double> methodWithMapDoubleReturn(Handler<String> handler) { 
    Map<String, Double> ret = delegate.methodWithMapDoubleReturn(handler);
    return ret;
  }

  public Map<String, JsonObject> methodWithMapJsonObjectReturn(Handler<String> handler) { 
    Map<String, JsonObject> ret = delegate.methodWithMapJsonObjectReturn(handler);
    return ret;
  }

  public Map<String, JsonObject> methodWithMapComplexJsonObjectReturn(Handler<String> handler) { 
    Map<String, JsonObject> ret = delegate.methodWithMapComplexJsonObjectReturn(handler);
    return ret;
  }

  public Map<String, JsonArray> methodWithMapJsonArrayReturn(Handler<String> handler) { 
    Map<String, JsonArray> ret = delegate.methodWithMapJsonArrayReturn(handler);
    return ret;
  }

  public Map<String, JsonArray> methodWithMapComplexJsonArrayReturn(Handler<String> handler) { 
    Map<String, JsonArray> ret = delegate.methodWithMapComplexJsonArrayReturn(handler);
    return ret;
  }

  public Map<String, Object> methodWithMapObjectReturn(Handler<String> handler) { 
    Map<String, Object> ret = delegate.methodWithMapObjectReturn(handler);
    return ret;
  }

  public List<String> methodWithListStringReturn() { 
    List<String> ret = delegate.methodWithListStringReturn();
    return ret;
  }

  public List<Long> methodWithListLongReturn() { 
    List<Long> ret = delegate.methodWithListLongReturn();
    return ret;
  }

  public List<io.vertx.rxjava.codegen.testmodel.RefedInterface1> methodWithListVertxGenReturn() { 
    List<io.vertx.rxjava.codegen.testmodel.RefedInterface1> ret = delegate.methodWithListVertxGenReturn().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toList());
    return ret;
  }

  public List<JsonObject> methodWithListJsonObjectReturn() { 
    List<JsonObject> ret = delegate.methodWithListJsonObjectReturn();
    return ret;
  }

  public List<JsonObject> methodWithListComplexJsonObjectReturn() { 
    List<JsonObject> ret = delegate.methodWithListComplexJsonObjectReturn();
    return ret;
  }

  public List<JsonArray> methodWithListJsonArrayReturn() { 
    List<JsonArray> ret = delegate.methodWithListJsonArrayReturn();
    return ret;
  }

  public List<JsonArray> methodWithListComplexJsonArrayReturn() { 
    List<JsonArray> ret = delegate.methodWithListComplexJsonArrayReturn();
    return ret;
  }

  public List<TestDataObject> methodWithListDataObjectReturn() { 
    List<TestDataObject> ret = delegate.methodWithListDataObjectReturn();
    return ret;
  }

  public List<TestEnum> methodWithListEnumReturn() { 
    List<TestEnum> ret = delegate.methodWithListEnumReturn();
    return ret;
  }

  public List<Object> methodWithListObjectReturn() { 
    List<Object> ret = delegate.methodWithListObjectReturn();
    return ret;
  }

  public Set<String> methodWithSetStringReturn() { 
    Set<String> ret = delegate.methodWithSetStringReturn();
    return ret;
  }

  public Set<Long> methodWithSetLongReturn() { 
    Set<Long> ret = delegate.methodWithSetLongReturn();
    return ret;
  }

  public Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1> methodWithSetVertxGenReturn() { 
    Set<io.vertx.rxjava.codegen.testmodel.RefedInterface1> ret = delegate.methodWithSetVertxGenReturn().stream().map(elt -> io.vertx.rxjava.codegen.testmodel.RefedInterface1.newInstance(elt)).collect(java.util.stream.Collectors.toSet());
    return ret;
  }

  public Set<JsonObject> methodWithSetJsonObjectReturn() { 
    Set<JsonObject> ret = delegate.methodWithSetJsonObjectReturn();
    return ret;
  }

  public Set<JsonObject> methodWithSetComplexJsonObjectReturn() { 
    Set<JsonObject> ret = delegate.methodWithSetComplexJsonObjectReturn();
    return ret;
  }

  public Set<JsonArray> methodWithSetJsonArrayReturn() { 
    Set<JsonArray> ret = delegate.methodWithSetJsonArrayReturn();
    return ret;
  }

  public Set<JsonArray> methodWithSetComplexJsonArrayReturn() { 
    Set<JsonArray> ret = delegate.methodWithSetComplexJsonArrayReturn();
    return ret;
  }

  public Set<TestDataObject> methodWithSetDataObjectReturn() { 
    Set<TestDataObject> ret = delegate.methodWithSetDataObjectReturn();
    return ret;
  }

  public Set<TestEnum> methodWithSetEnumReturn() { 
    Set<TestEnum> ret = delegate.methodWithSetEnumReturn();
    return ret;
  }

  public Set<Object> methodWithSetObjectReturn() { 
    Set<Object> ret = delegate.methodWithSetObjectReturn();
    return ret;
  }


  public static  CollectionTCK newInstance(io.vertx.codegen.testmodel.CollectionTCK arg) {
    return arg != null ? new CollectionTCK(arg) : null;
  }
}
