/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.testmodel;

import java.util.Map;
import rx.Observable;
import rx.Single;
import io.vertx.codegen.testmodel.TestDataObject;
import java.util.function.Function;
import io.vertx.core.json.JsonArray;
import io.vertx.codegen.testmodel.TestEnum;
import io.vertx.core.json.JsonObject;
import io.vertx.core.AsyncResult;
import io.vertx.core.Handler;
import io.vertx.codegen.testmodel.TestGenEnum;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.GenericsTCK original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.codegen.testmodel.GenericsTCK.class)
public class GenericsTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    GenericsTCK that = (GenericsTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<GenericsTCK> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new GenericsTCK((io.vertx.codegen.testmodel.GenericsTCK) obj),
    GenericsTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.GenericsTCK delegate;
  
  public GenericsTCK(io.vertx.codegen.testmodel.GenericsTCK delegate) {
    this.delegate = delegate;
  }

  public io.vertx.codegen.testmodel.GenericsTCK getDelegate() {
    return delegate;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte> methodWithByteParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithByteParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short> methodWithShortParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithShortParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer> methodWithIntegerParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithIntegerParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long> methodWithLongParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithLongParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float> methodWithFloatParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithFloatParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double> methodWithDoubleParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithDoubleParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean> methodWithBooleanParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithBooleanParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character> methodWithCharacterParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithCharacterParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String> methodWithStringParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithStringParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject> methodWithJsonObjectParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithJsonObjectParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray> methodWithJsonArrayParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithJsonArrayParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject> methodWithDataObjectParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithDataObjectParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum> methodWithEnumParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithEnumParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum> methodWithGenEnumParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithGenEnumParameterizedReturn(), io.vertx.lang.rx.TypeArg.unknown());
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1> methodWithUserTypeParameterizedReturn() { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithUserTypeParameterizedReturn(), (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG);
    return ret;
  }

  public void methodWithHandlerByteParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>> handler) { 
    delegate.methodWithHandlerByteParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerShortParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>> handler) { 
    delegate.methodWithHandlerShortParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerIntegerParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>> handler) { 
    delegate.methodWithHandlerIntegerParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerLongParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>> handler) { 
    delegate.methodWithHandlerLongParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerFloatParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>> handler) { 
    delegate.methodWithHandlerFloatParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerDoubleParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>> handler) { 
    delegate.methodWithHandlerDoubleParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerBooleanParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>> handler) { 
    delegate.methodWithHandlerBooleanParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerCharacterParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>> handler) { 
    delegate.methodWithHandlerCharacterParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerStringParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>> handler) { 
    delegate.methodWithHandlerStringParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerJsonObjectParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>> handler) { 
    delegate.methodWithHandlerJsonObjectParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerJsonArrayParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>> handler) { 
    delegate.methodWithHandlerJsonArrayParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerDataObjectParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>> handler) { 
    delegate.methodWithHandlerDataObjectParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerEnumParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>> handler) { 
    delegate.methodWithHandlerEnumParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerGenEnumParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>> handler) { 
    delegate.methodWithHandlerGenEnumParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.unknown()));
      }
    });
  }

  public void methodWithHandlerUserTypeParameterized(Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithHandlerUserTypeParameterized(new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG));
      }
    });
  }

  public void methodWithHandlerAsyncResultByteParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>>> handler) { 
    delegate.methodWithHandlerAsyncResultByteParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>> methodWithHandlerAsyncResultByteParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultByteParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>> rxMethodWithHandlerAsyncResultByteParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultByteParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultShortParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>>> handler) { 
    delegate.methodWithHandlerAsyncResultShortParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>> methodWithHandlerAsyncResultShortParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultShortParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>> rxMethodWithHandlerAsyncResultShortParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultShortParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultIntegerParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>>> handler) { 
    delegate.methodWithHandlerAsyncResultIntegerParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>> methodWithHandlerAsyncResultIntegerParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultIntegerParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>> rxMethodWithHandlerAsyncResultIntegerParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultIntegerParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultLongParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>>> handler) { 
    delegate.methodWithHandlerAsyncResultLongParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>> methodWithHandlerAsyncResultLongParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultLongParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>> rxMethodWithHandlerAsyncResultLongParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultLongParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultFloatParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>>> handler) { 
    delegate.methodWithHandlerAsyncResultFloatParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>> methodWithHandlerAsyncResultFloatParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultFloatParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>> rxMethodWithHandlerAsyncResultFloatParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultFloatParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultDoubleParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>>> handler) { 
    delegate.methodWithHandlerAsyncResultDoubleParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>> methodWithHandlerAsyncResultDoubleParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultDoubleParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>> rxMethodWithHandlerAsyncResultDoubleParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultDoubleParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultBooleanParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>>> handler) { 
    delegate.methodWithHandlerAsyncResultBooleanParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>> methodWithHandlerAsyncResultBooleanParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultBooleanParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>> rxMethodWithHandlerAsyncResultBooleanParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultBooleanParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultCharacterParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>>> handler) { 
    delegate.methodWithHandlerAsyncResultCharacterParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>> methodWithHandlerAsyncResultCharacterParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultCharacterParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>> rxMethodWithHandlerAsyncResultCharacterParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultCharacterParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultStringParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>>> handler) { 
    delegate.methodWithHandlerAsyncResultStringParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>> methodWithHandlerAsyncResultStringParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultStringParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>> rxMethodWithHandlerAsyncResultStringParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultStringParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultJsonObjectParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>>> handler) { 
    delegate.methodWithHandlerAsyncResultJsonObjectParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>> methodWithHandlerAsyncResultJsonObjectParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultJsonObjectParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>> rxMethodWithHandlerAsyncResultJsonObjectParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultJsonObjectParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultJsonArrayParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>>> handler) { 
    delegate.methodWithHandlerAsyncResultJsonArrayParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>> methodWithHandlerAsyncResultJsonArrayParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultJsonArrayParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>> rxMethodWithHandlerAsyncResultJsonArrayParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultJsonArrayParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultDataObjectParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>>> handler) { 
    delegate.methodWithHandlerAsyncResultDataObjectParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>> methodWithHandlerAsyncResultDataObjectParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultDataObjectParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>> rxMethodWithHandlerAsyncResultDataObjectParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultDataObjectParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultEnumParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>>> handler) { 
    delegate.methodWithHandlerAsyncResultEnumParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>> methodWithHandlerAsyncResultEnumParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultEnumParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>> rxMethodWithHandlerAsyncResultEnumParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultEnumParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultGenEnumParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>>> handler) { 
    delegate.methodWithHandlerAsyncResultGenEnumParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.unknown())));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>> methodWithHandlerAsyncResultGenEnumParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultGenEnumParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>> rxMethodWithHandlerAsyncResultGenEnumParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultGenEnumParameterized(fut);
    }));
  }

  public void methodWithHandlerAsyncResultUserTypeParameterized(Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithHandlerAsyncResultUserTypeParameterized(new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG)));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> methodWithHandlerAsyncResultUserTypeParameterizedObservable() { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultUserTypeParameterized(handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultUserTypeParameterized() { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultUserTypeParameterized(fut);
    }));
  }

  public void methodWithFunctionParamByteParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Byte>, String> handler) { 
    delegate.methodWithFunctionParamByteParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Byte> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamShortParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Short>, String> handler) { 
    delegate.methodWithFunctionParamShortParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Short> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamIntegerParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Integer>, String> handler) { 
    delegate.methodWithFunctionParamIntegerParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Integer> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamLongParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Long>, String> handler) { 
    delegate.methodWithFunctionParamLongParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Long> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamFloatParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Float>, String> handler) { 
    delegate.methodWithFunctionParamFloatParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Float> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamDoubleParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Double>, String> handler) { 
    delegate.methodWithFunctionParamDoubleParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Double> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamBooleanParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Boolean>, String> handler) { 
    delegate.methodWithFunctionParamBooleanParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Boolean> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamCharacterParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<Character>, String> handler) { 
    delegate.methodWithFunctionParamCharacterParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.Character> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamStringParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<String>, String> handler) { 
    delegate.methodWithFunctionParamStringParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<java.lang.String> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamJsonObjectParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonObject>, String> handler) { 
    delegate.methodWithFunctionParamJsonObjectParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonObject> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamJsonArrayParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<JsonArray>, String> handler) { 
    delegate.methodWithFunctionParamJsonArrayParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.core.json.JsonArray> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamDataObjectParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestDataObject>, String> handler) { 
    delegate.methodWithFunctionParamDataObjectParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestDataObject> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamEnumParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestEnum>, String> handler) { 
    delegate.methodWithFunctionParamEnumParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestEnum> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamGenEnumParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<TestGenEnum>, String> handler) { 
    delegate.methodWithFunctionParamGenEnumParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.TestGenEnum> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.unknown()));
        return ret;
      }
    });
  }

  public void methodWithFunctionParamUserTypeParameterized(Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>, String> handler) { 
    delegate.methodWithFunctionParamUserTypeParameterized(new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<io.vertx.codegen.testmodel.RefedInterface1> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG));
        return ret;
      }
    });
  }

  public <U> io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U> methodWithClassTypeParameterizedReturn(Class<U> type) { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithClassTypeParameterizedReturn(io.vertx.lang.rxjava.Helper.unwrap(type)), io.vertx.lang.rx.TypeArg.of(type));
    return ret;
  }

  public <U> void methodWithHandlerClassTypeParameterized(Class<U> type, Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>> handler) { 
    delegate.methodWithHandlerClassTypeParameterized(io.vertx.lang.rxjava.Helper.unwrap(type), new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<U>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<U> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, io.vertx.lang.rx.TypeArg.of(type)));
      }
    });
  }

  public <U> void methodWithHandlerAsyncResultClassTypeParameterized(Class<U> type, Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>>> handler) { 
    delegate.methodWithHandlerAsyncResultClassTypeParameterized(io.vertx.lang.rxjava.Helper.unwrap(type), new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<U>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<U>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), io.vertx.lang.rx.TypeArg.of(type))));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public <U> Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>> methodWithHandlerAsyncResultClassTypeParameterizedObservable(Class<U> type) { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultClassTypeParameterized(type, handler.toHandler());
    return handler;
  }

  public <U> Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>> rxMethodWithHandlerAsyncResultClassTypeParameterized(Class<U> type) { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultClassTypeParameterized(type, fut);
    }));
  }

  public <U> void methodWithFunctionParamClassTypeParameterized(Class<U> type, Function<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<U>, String> handler) { 
    delegate.methodWithFunctionParamClassTypeParameterized(io.vertx.lang.rxjava.Helper.unwrap(type), new java.util.function.Function<io.vertx.codegen.testmodel.GenericRefedInterface<U>,java.lang.String>() {
      public java.lang.String apply(io.vertx.codegen.testmodel.GenericRefedInterface<U> arg) {
        String ret = handler.apply(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(arg, io.vertx.lang.rx.TypeArg.of(type)));
        return ret;
      }
    });
  }

  public <U> void methodWithClassTypeParam(Class<U> type, U u) { 
    delegate.methodWithClassTypeParam(io.vertx.lang.rxjava.Helper.unwrap(type), io.vertx.lang.rx.TypeArg.of(type).<U>unwrap(u));
  }

  public <U> U methodWithClassTypeReturn(Class<U> type) { 
    U ret = (U)io.vertx.lang.rx.TypeArg.of(type).wrap(delegate.methodWithClassTypeReturn(io.vertx.lang.rxjava.Helper.unwrap(type)));
    return ret;
  }

  public <U> void methodWithClassTypeHandler(Class<U> type, Handler<U> f) { 
    delegate.methodWithClassTypeHandler(io.vertx.lang.rxjava.Helper.unwrap(type), new Handler<U>() {
      public void handle(U event) {
        f.handle((U)io.vertx.lang.rx.TypeArg.of(type).wrap(event));
      }
    });
  }

  public <U> void methodWithClassTypeHandlerAsyncResult(Class<U> type, Handler<AsyncResult<U>> f) { 
    delegate.methodWithClassTypeHandlerAsyncResult(io.vertx.lang.rxjava.Helper.unwrap(type), new Handler<AsyncResult<U>>() {
      public void handle(AsyncResult<U> ar) {
        if (ar.succeeded()) {
          f.handle(io.vertx.core.Future.succeededFuture((U)io.vertx.lang.rx.TypeArg.of(type).wrap(ar.result())));
        } else {
          f.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public <U> Observable<U> methodWithClassTypeHandlerAsyncResultObservable(Class<U> type) { 
    io.vertx.rx.java.ObservableFuture<U> f = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithClassTypeHandlerAsyncResult(type, f.toHandler());
    return f;
  }

  public <U> Single<U> rxMethodWithClassTypeHandlerAsyncResult(Class<U> type) { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithClassTypeHandlerAsyncResult(type, fut);
    }));
  }

  public <U> void methodWithClassTypeFunctionParam(Class<U> type, Function<U, String> f) { 
    delegate.methodWithClassTypeFunctionParam(io.vertx.lang.rxjava.Helper.unwrap(type), new java.util.function.Function<U,java.lang.String>() {
      public java.lang.String apply(U arg) {
        String ret = f.apply((U)io.vertx.lang.rx.TypeArg.of(type).wrap(arg));
        return ret;
      }
    });
  }

  public <U> void methodWithClassTypeFunctionReturn(Class<U> type, Function<String, U> f) { 
    delegate.methodWithClassTypeFunctionReturn(io.vertx.lang.rxjava.Helper.unwrap(type), new java.util.function.Function<java.lang.String,U>() {
      public U apply(java.lang.String arg) {
        U ret = f.apply(arg);
        return io.vertx.lang.rx.TypeArg.of(type).<U>unwrap(ret);
      }
    });
  }

  public io.vertx.rxjava.codegen.testmodel.InterfaceWithApiArg interfaceWithApiArg(io.vertx.rxjava.codegen.testmodel.RefedInterface1 value) { 
    io.vertx.rxjava.codegen.testmodel.InterfaceWithApiArg ret = io.vertx.rxjava.codegen.testmodel.InterfaceWithApiArg.newInstance(delegate.interfaceWithApiArg(value.getDelegate()));
    return ret;
  }

  public io.vertx.rxjava.codegen.testmodel.InterfaceWithStringArg interfaceWithStringArg(String value) { 
    io.vertx.rxjava.codegen.testmodel.InterfaceWithStringArg ret = io.vertx.rxjava.codegen.testmodel.InterfaceWithStringArg.newInstance(delegate.interfaceWithStringArg(value));
    return ret;
  }

  public <T, U> io.vertx.rxjava.codegen.testmodel.InterfaceWithVariableArg<T, U> interfaceWithVariableArg(T value1, Class<U> type, U value2) { 
    io.vertx.rxjava.codegen.testmodel.InterfaceWithVariableArg<T, U> ret = io.vertx.rxjava.codegen.testmodel.InterfaceWithVariableArg.newInstance(delegate.interfaceWithVariableArg(value1, io.vertx.lang.rxjava.Helper.unwrap(type), io.vertx.lang.rx.TypeArg.of(type).<U>unwrap(value2)), io.vertx.lang.rx.TypeArg.unknown(), io.vertx.lang.rx.TypeArg.of(type));
    return ret;
  }

  public void methodWithHandlerGenericNullableApi(boolean notNull, Handler<io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> handler) { 
    delegate.methodWithHandlerGenericNullableApi(notNull, new Handler<io.vertx.codegen.testmodel.GenericNullableRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>>() {
      public void handle(io.vertx.codegen.testmodel.GenericNullableRefedInterface<io.vertx.codegen.testmodel.RefedInterface1> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface.newInstance(event, (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG));
      }
    });
  }

  public void methodWithHandlerAsyncResultGenericNullableApi(boolean notNull, Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>>> handler) { 
    delegate.methodWithHandlerAsyncResultGenericNullableApi(notNull, new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericNullableRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericNullableRefedInterface<io.vertx.codegen.testmodel.RefedInterface1>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface.newInstance(ar.result(), (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG)));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public Observable<io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> methodWithHandlerAsyncResultGenericNullableApiObservable(boolean notNull) { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultGenericNullableApi(notNull, handler.toHandler());
    return handler;
  }

  public Single<io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1>> rxMethodWithHandlerAsyncResultGenericNullableApi(boolean notNull) { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultGenericNullableApi(notNull, fut);
    }));
  }

  public io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1> methodWithGenericNullableApiReturn(boolean notNull) { 
    io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface<io.vertx.rxjava.codegen.testmodel.RefedInterface1> ret = io.vertx.rxjava.codegen.testmodel.GenericNullableRefedInterface.newInstance(delegate.methodWithGenericNullableApiReturn(notNull), (io.vertx.lang.rx.TypeArg)io.vertx.rxjava.codegen.testmodel.RefedInterface1.__TYPE_ARG);
    return ret;
  }

  public <T> io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> methodWithParamInferedReturn(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> param) { 
    io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> ret = io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(delegate.methodWithParamInferedReturn(param.getDelegate()), param.__typeArg_0);
    return ret;
  }

  public <T> void methodWithHandlerParamInfered(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> param, Handler<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T>> handler) { 
    delegate.methodWithHandlerParamInfered(param.getDelegate(), new Handler<io.vertx.codegen.testmodel.GenericRefedInterface<T>>() {
      public void handle(io.vertx.codegen.testmodel.GenericRefedInterface<T> event) {
        handler.handle(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(event, param.__typeArg_0));
      }
    });
  }

  public <T> void methodWithHandlerAsyncResultParamInfered(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> param, Handler<AsyncResult<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T>>> handler) { 
    delegate.methodWithHandlerAsyncResultParamInfered(param.getDelegate(), new Handler<AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<T>>>() {
      public void handle(AsyncResult<io.vertx.codegen.testmodel.GenericRefedInterface<T>> ar) {
        if (ar.succeeded()) {
          handler.handle(io.vertx.core.Future.succeededFuture(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface.newInstance(ar.result(), param.__typeArg_0)));
        } else {
          handler.handle(io.vertx.core.Future.failedFuture(ar.cause()));
        }
      }
    });
  }

    @Deprecated()
  public <T> Observable<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T>> methodWithHandlerAsyncResultParamInferedObservable(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> param) { 
    io.vertx.rx.java.ObservableFuture<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T>> handler = io.vertx.rx.java.RxHelper.observableFuture();
    methodWithHandlerAsyncResultParamInfered(param, handler.toHandler());
    return handler;
  }

  public <T> Single<io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T>> rxMethodWithHandlerAsyncResultParamInfered(io.vertx.rxjava.codegen.testmodel.GenericRefedInterface<T> param) { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      methodWithHandlerAsyncResultParamInfered(param, fut);
    }));
  }


  public static  GenericsTCK newInstance(io.vertx.codegen.testmodel.GenericsTCK arg) {
    return arg != null ? new GenericsTCK(arg) : null;
  }
}
